package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityClamp;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import it.unimi.dsi.fastutil.objects.ObjectListIterator;
import java.util.function.Function;
import net.minecraft.util.RandomSource;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import net.minecraftforge.common.loot.LootModifier;

public class AffixConvertLootModifier extends LootModifier {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.loot.AffixConvertLootModifier> CODEC;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> codecStart(inst).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.loot.AffixConvertLootModifier::new));
  }
  
  protected AffixConvertLootModifier(LootItemCondition[] conditionsIn) {
    super(conditionsIn);
  }
  
  protected ObjectArrayList<ItemStack> doApply(ObjectArrayList<ItemStack> generatedLoot, LootContext context) {
    if (!Apotheosis.enableAdventure)
      return generatedLoot; 
    for (AdventureConfig.LootPatternMatcher m : AdventureConfig.AFFIX_CONVERT_LOOT_RULES) {
      if (m.matches(context.getQueriedLootTableId())) {
        RarityClamp rarities = (RarityClamp)AdventureConfig.AFFIX_CONVERT_RARITIES.get(context.m_78952_().m_46472_().m_135782_());
        RandomSource rand = context.m_230907_();
        float luck = context.m_78945_();
        for (ObjectListIterator<ItemStack> objectListIterator = generatedLoot.iterator(); objectListIterator.hasNext(); ) {
          ItemStack s = objectListIterator.next();
          if (!LootCategory.forItem(s).isNone() && AffixHelper.getAffixes(s).isEmpty() && rand.m_188501_() <= m.chance())
            LootController.createLootItem(s, LootRarity.random(rand, luck, rarities), rand); 
        } 
        break;
      } 
    } 
    return generatedLoot;
  }
  
  public Codec<? extends IGlobalLootModifier> codec() {
    return (Codec)CODEC;
  }
}
